function tick () {
    led.plot(4, 0)
    basic.pause(100)
    led.unplot(4, 0)
    led.toggle(4, 1)
    basic.pause(100)
    led.unplot(4, 1)
}
function anticlk () {
    for (let index = 0; index <= 7; index++) {
        set_bit(index)
    }
}
function homing () {
    home = false
    timer = control.millis()
    index = 0
    while (pins.digitalReadPin(DigitalPin.P0) == 1 && control.millis() - timer < 60000) {
        clkwise()
        index += 1
        if (index > 512) {
            index = 0
        }
    }
    basic.pause(100)
    if (pins.digitalReadPin(DigitalPin.P0) == 0) {
        home = true
    }
    motor_off()
}
function motor_off () {
    pins.digitalWritePin(DigitalPin.P13, 0)
    pins.digitalWritePin(DigitalPin.P14, 0)
    pins.digitalWritePin(DigitalPin.P15, 0)
    pins.digitalWritePin(DigitalPin.P16, 0)
}
function dec2bin (value: number) {
    col = 0
    digit = text_digit[value]
    for (let digit_col = 0; digit_col <= 4; digit_col++) {
        col_val = parseFloat(digit.substr(digit_col * 2, 2))
        list2 = [
        0,
        0,
        0,
        0,
        0
        ]
        index = 0
        while (index <= list2.length) {
            if (col_val > 1) {
                list2[index] = col_val % 2
                col_val = Math.idiv(col_val, 2)
            } else {
                list2[index] = col_val
                break;
            }
            index += 1
        }
        if (index2 == 1) {
            index2 = 0
            while (index2 <= list2.length) {
                let list: number[] = []
                if (list[index2] == 1) {
                    led.plot(col, index2)
                    bit = 1
                } else {
                    led.unplot(col, index2)
                    bit = 0
                }
                index2 += 1
            }
            basic.pause(0)
        }
        pos_min(1)
        LED_arm(col)
        col += 1
    }
    pos_min(1)
    char_gap()
}
function LED_arm (num: number) {
    intensity = 180
    basic.clearScreen()
    led.plot(num, 0)
    if (list2[0] == 1) {
        Kitronik_Robotics_Board.servoWrite(Kitronik_Robotics_Board.Servos.Servo1, intensity)
    } else {
        Kitronik_Robotics_Board.servoStop(Kitronik_Robotics_Board.Servos.Servo1)
    }
    if (list2[1] == 1) {
        Kitronik_Robotics_Board.servoWrite(Kitronik_Robotics_Board.Servos.Servo2, intensity)
    } else {
        Kitronik_Robotics_Board.servoStop(Kitronik_Robotics_Board.Servos.Servo2)
    }
    if (list2[2] == 1) {
        Kitronik_Robotics_Board.servoWrite(Kitronik_Robotics_Board.Servos.Servo3, intensity)
    } else {
        Kitronik_Robotics_Board.servoStop(Kitronik_Robotics_Board.Servos.Servo3)
    }
    if (list2[3] == 1) {
        Kitronik_Robotics_Board.servoWrite(Kitronik_Robotics_Board.Servos.Servo4, intensity)
    } else {
        Kitronik_Robotics_Board.servoStop(Kitronik_Robotics_Board.Servos.Servo4)
    }
    if (list2[4] == 1) {
        Kitronik_Robotics_Board.servoWrite(Kitronik_Robotics_Board.Servos.Servo5, intensity)
    } else {
        Kitronik_Robotics_Board.servoStop(Kitronik_Robotics_Board.Servos.Servo5)
    }
    basic.pause(500)
    Kitronik_Robotics_Board.allOff()
}
// read set mode switch
function set_mode () {
    set_enable = pins.digitalReadPin(DigitalPin.P1)
    if (set_enable == 1) {
        basic.showString("+")
    }
}
function rd_time () {
    strval = "+" + DS3231.timeString().substr(0, 6)
    if (DS3231.minutes() == 0) {
        music.playSoundEffect(music.builtinSoundEffect(soundExpression.spring), SoundExpressionPlayMode.UntilDone)
    }
}
function show_tm () {
    basic.clearScreen()
    pins.digitalWritePin(DigitalPin.P8, 0)
    rd_time()
    basic.showString(strval.substr(1, 5))
    for (let index = 0; index <= strval.length - 1; index++) {
        strmid = strval.charAt(strval.length - 1 - index)
        if (strmid != ":") {
            if (strmid == "+") {
                item = 10
            } else {
                item = parseFloat(strmid)
            }
            dec2bin(item)
        }
    }
    pins.digitalWritePin(DigitalPin.P8, 1)
    basic.clearScreen()
    pos_min(15)
    motor_off()
    long_dly()
}
input.onButtonPressed(Button.A, function () {
    if (set_enable == 1) {
        set_hr += 1
        if (set_hr > 23) {
            set_hr = 0
        }
        basic.showNumber(set_hr)
    }
})
function set_bit (num: number) {
    motorbits = beat_list[num]
    pins.digitalWritePin(DigitalPin.P13, parseFloat(motorbits.substr(0, 1)))
    pins.digitalWritePin(DigitalPin.P14, parseFloat(motorbits.substr(1, 1)))
    pins.digitalWritePin(DigitalPin.P15, parseFloat(motorbits.substr(2, 1)))
    pins.digitalWritePin(DigitalPin.P16, parseFloat(motorbits.substr(3, 1)))
    basic.pause(1.2)
}
function pos_min (num: number) {
    // steps = ((min*6)*1.42222)-256
    // 512/360 = 1.422222 step/deg
    min = Math.trunc(num * chrwidth * 1.422222 - 0)
    if (min >= 0) {
        for (let index = 0; index <= Math.abs(min); index++) {
            anticlk()
        }
    } else {
        for (let index = 0; index <= Math.abs(min); index++) {
            clkwise()
        }
    }
}
function settime () {
    DS3231.setTime(set_hr, set_min, 0)
    basic.showNumber(set_hr)
    basic.pause(100)
    basic.showNumber(set_min)
    basic.pause(100)
}
function char_gap () {
    list2 = [
    0,
    0,
    0,
    0,
    0
    ]
    LED_arm(0)
}
function long_dly () {
    timer = control.millis()
    while (control.millis() - timer < 60000) {
        tick()
        set_mode()
        if (set_enable == 1) {
            break;
        }
    }
}
input.onButtonPressed(Button.AB, function () {
    if (set_enable == 1) {
        settime()
        basic.clearScreen()
    }
})
input.onButtonPressed(Button.B, function () {
    if (set_enable == 1) {
        set_min += 1
        if (set_min > 59) {
            set_min = 0
        }
        basic.showNumber(set_min)
    }
})
function home_time () {
    basic.clearScreen()
    basic.showLeds(`
        . # # # .
        # . # . #
        # . # . #
        # . . . #
        . # # # .
        `)
    homing()
    basic.clearScreen()
}
function clkwise () {
    inc = 8
    for (let index = 0; index <= 7; index++) {
        inc += -1
        set_bit(inc)
    }
}
let inc = 0
let min = 0
let item = 0
let intensity = 0
let bit = 0
let list2: number[] = []
let digit = ""
let col = 0
let index = 0
let timer = 0
let text_digit: string[] = []
let motorbits = ""
let beat_list: string[] = []
let home = false
let set_min = 0
let set_hr = 0
let set_enable = 0
let index2 = 0
let strmid = ""
let strval = ""
let col_val = 0
let chrwidth = 0
music.setBuiltInSpeakerEnabled(true)
pins.setPull(DigitalPin.P1, PinPullMode.PullUp)
// disable LED buffer
pins.digitalWritePin(DigitalPin.P8, 1)
motor_off()
basic.showString("sclk")
basic.pause(1000)
chrwidth = 5
col_val = 0
strval = ""
strmid = ""
index2 = 0
set_enable = 1
set_hr = 0
set_min = 0
home = false
// stepper motor beat list
beat_list = [
"1000",
"1100",
"0100",
"0110",
"0010",
"0011",
"0001",
"1001",
"0000"
]
motorbits = ""
text_digit = [
"1417211714",
"1616311818",
"1821212125",
"1021211710",
"0831091012",
"0821212123",
"0821182008",
"0103050917",
"1021212110",
"0205132102",
"0000000000"
]
home_time()
basic.forever(function () {
    set_mode()
    if (set_enable == 0) {
        home_time()
        if (home == true) {
            tick()
            show_tm()
            basic.clearScreen()
        } else {
            basic.showIcon(IconNames.No)
        }
    }
})
